#include<stdio.h>
#include<math.h>
#include<stdlib.h>              /* Guida slab 5 strati*/
#include<conio.h>
#include<dos.h>
#include<graphics.h>
#include<ctype.h>
#include<string.h>

#define pi 3.141592654
#define MAXIT 30
#define ESC 27      // 27  il codice ascii di Esc

// prototipi delle funzioni void nome_funz(void) => la funz non ritorna valore
int dati_in_ingresso(void); //e non gli passo nessun parametro (void=vuoto)
int  inizializza_grafica();
double calcolo_dete(double No1,double No2,double No3,double No4,double No5,
					double k0, double Nef);
double zeri_sec(double Nef,double oldNef,double deter,double olddeter,
				double eps, double k0);
void verif_nef(double X[5], double Nef);
int simq(void);
void campi_E(double X[5]);
void trova_nef(double deltadeltan, double k0);
void disegna();
void disegna_3d();

// dichiarazione e inizializzazione di tutte le var extern o globali
int      dimnef=6, dimmap=100, step=100, nj=-1, d=0 ,npix=300, kmax=20;
int      a=0, b=0, c=0, flag=0, segno=1;
double   No1=3.20, No2=3.30, No3=3.20, No4=3.30, No5=3.20;
double   h1=0.0, h2=0.0, h3=0.0, h4=0.0, h5=0.0, la=0.0;
double   d2=1.0, d3=1.0, d4=1.0, lambda=1.5010; //0.494740
double   Nmin=0.0, Nmax=0.0, Nef=0.0, oldNef=0.0, matmap[5][300], l=0.0;
double   *nefok=new double[dimnef];  // vettore dinamico



int inizializza_grafica()
{
	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();
	if (errorcode != grOk)
	{
	  printf("Errore durante l'inizializzazione della grafica -> %s\n", grapherrormsg(errorcode));
	  printf("premi un tasto per terminare:");
	  getch();
	  exit(1);             /* ritorna il codice dell'errore */
	}
	return 0;
}


int dati_in_ingresso(void)
{
	char dat_in[10], tasto;
	double dati=0.0;
	int err=0;

	settextstyle(TRIPLEX_FONT,0,3);setbkcolor(BLACK);cleardevice();
	setcolor(GREEN);
	outtextxy(230,0,"ACCOPPIATORE");
	gotoxy(1,3);printf("Assegna gli indici di rifrazione: tra parentesi ci sono i valori di default\n");
	printf("- No1 (%2.8f)= ",No1);
	dati=atof(gets(dat_in));
	if (dati!=0) No1=dati;
	gotoxy(45,4); printf(" (No1=%2.8f)\n",No1);

	printf("- No2 (%2.8f)= ",No2);
	dati=atof(gets(dat_in));
	if (dati!=0) No2=dati;
	gotoxy(45,5); printf(" (No2=%2.8f)\n",No2);

	printf("- No3 (%2.8f)= ",No3);
	dati=atof(gets(dat_in));
	if (dati!=0) No3=dati;
	gotoxy(45,6); printf(" (No3=%2.8f)\n",No3);

	printf("- No4 (%2.8f)= ",No4);
	dati=atof(gets(dat_in));
	if (dati!=0) No4=dati;
	gotoxy(45,7); printf(" (No4=%2.8f)\n",No4);

	printf("- No5 (%2.8f)= ",No5);
	dati=atof(gets(dat_in));
	if (dati!=0) No5=dati;
	gotoxy(45,8); printf(" (No5=%2.8f)\n",No5);

	printf("\nAssegna gli spessori e la lunghezza d'onda:");
	printf("\n- lambda (%2.8f)= ",lambda);//textcolor(LIGHTRED);
	dati=atof(gets(dat_in));
	if (dati!=0) lambda=dati;
	gotoxy(45,11); printf(" (lambda=%2.8f micron)\n",lambda);

	printf("- d2(core1) (%2.8f)= ",d2);
	dati=atof(gets(dat_in));
	if (dati!=0) d2=dati;
	gotoxy(45,12); printf(" (d2=%2.8f micron)\n",d2);

	printf("- gap (%2.8f)= ",d3);
	dati=atof(gets(dat_in));
	if (dati!=0) d3=dati;
	gotoxy(45,13); printf(" (d3=%2.8f micron)\n",d3);

	printf("- d4(core2) (%2.8f)= ",d4);
	dati=atof(gets(dat_in));
	if (dati!=0) d4=dati;
	gotoxy(45,14); printf(" (d4=%2.8f micron)\n",d4);

	printf("- n di passi (%d)= ",step);
	dati=atoi(gets(dat_in));
	if (dati!=0) step=dati;
	gotoxy(45,15); printf(" (passi=%d)\n",step);

	printf("- n dei pixel (%d)= ",npix);
	dati=atoi(gets(dat_in));
	if (dati!=0) npix=dati;
	gotoxy(45,16); printf(" (%d pixel)\n",npix);

	printf("- n delle sezioni dz che si vuole visualizzare  (%d)= ",kmax);
	dati=atoi(gets(dat_in));
	if (dati!=0) kmax=dati;
	gotoxy(50,17);printf("(%d sez. lungo l'asse z)",kmax);

	gotoxy(15,19);
	printf("- Se i dati sono esatti premi s altrimenti premi n -\n");
	do
	 tasto=getch();  // fino a quando il tasto premuto non  n,N o s,S non prosegue
	while ((tasto!=78) && (tasto!=110) && (tasto!=83) && (tasto!=115));
	if((tasto==78) || (tasto==110)) err=5; // N-n maiusc-minusc
	if ( (!err) && (lambda<0 || d2<0 || d3<0 || d4<0 || step<=0) )
		{
		sound(50); delay(150); nosound();
		printf("    Errori nelle dimensioni assegnate, premi un tasto per riassegnare i dati\n");
		getch();
		err=1;
		}
// controllo degli indici ordinari in input
	if (!err) // gli Nord=>gli h devono essere tali che in core1/2 cio h2/h4
		{      // devono essere reali per avere una soluz. tipo seno,coseno
		Nmax=No2;
		if ( No2>No4 ) Nmax=No4;
		if ( No1>=No3 && No1>=No5 ) Nmin=No1;
		if ( No3>=No1 && No3>=No5 ) Nmin=No3;
		 else Nmin=No5;
		if (Nmax<Nmin || No1<=0 || No2<=0 || No3<=0 || No4<=0 || No5<=0 || No1>No3
			|| No1>No4 || No3>No4 || No3>No2)
			{
			sound(50); delay(150); nosound();
			printf("  	Errore negli indici di rifrazione ! ! O non esistono modi guidati! ! !");
			printf("\nPremi un tasto per riassegnare i dati.");
			getch();
			err=2;
			}
		}
		if ( (!err) && (npix<200 || npix>300) )
				{
				printf("    Errore nei dati !  ( 200 <= n punti=n pixel <= 300 )");
				printf("\nPremi un tasto per riassegnare i dati.");
				getch();
				npix=300;
				err=3;
				}
		if ( (!err) && (kmax<20 || kmax>=75) )
				{
				printf("    Errore nei dati !  ( 20 <= n sezioni <= 74 )");
				printf("\nPremi un tasto per riassegnare i dati.");
				getch();
				kmax=20;
				err=4;
				}
//      printf("\n  nel  dati_in_in passo=step=%d  err=%d",step,err);
	gotoxy(14,19);printf("                -  ATTENDERE PREGO  -                ");
	return err;
}


double calcolo_dete(double No1,double No2,double No3,double No4,double No5,
					double k0, double Nef)
{
	double A[6][6], C[6];
	double soglia=0.0, lik=0.0, dete=1.0;
	int n=6, i=0, k=0, m=0, jj=0, icmax=0;

	A[0][2]=A[0][4]=A[0][5]=A[1][2]=A[1][4]=A[1][5]=A[2][5]=A[3][5]=0;
	A[2][0]=A[3][0]=A[4][0]=A[5][0]=A[4][1]=A[5][1]=A[4][3]=A[5][3]=0;

	h1=k0*sqrt(Nef*Nef-No1*No1);
	h2=k0*sqrt(No2*No2-Nef*Nef);
	h3=k0*sqrt(Nef*Nef-No3*No3);
	h4=k0*sqrt(No4*No4-Nef*Nef);
	h5=k0*sqrt(Nef*Nef-No5*No5);

	A[0][0]=1;          A[0][1]=h3/h2*sin(h2*d2)-cos(h2*d2);

	A[0][3]=(-cos(h2*d2))-h3/h2*sin(h2*d2);

	A[1][0]=h1;             A[1][1]=(-h3*cos(h2*d2))-h2*sin(h2*d2);

	A[1][3]=(-h2*sin(h2*d2))+h3*cos(h2*d2);          A[2][1]=exp(h3*d3);

	A[2][2]=-cos(h4*d3);    A[2][3]=exp(-h3*d3);     A[2][4]=sin(h4*d3);

	A[3][1]=h3*exp(h3*d3);  A[3][2]=h4*sin(h4*d3);   A[3][3]=-h3*exp(-h3*d3);

	A[3][4]=h4*cos(h4*d3); A[4][2]=cos(h4*(d3+d4));  A[4][4]=-sin(h4*(d3+d4));

	A[4][5]=-1;             A[5][2]=-h4*sin(h4*(d3+d4));

	A[5][4]=-h4*cos(h4*(d3+d4));             A[5][5]=h5;

// trova il max sulla colonna i
	for (k=0;k<n;k++)
	{
		soglia=fabs(A[k][k]); icmax=k;
		for (i=k+1;i<n;i++)   // i=k+1 perch tanto so che prima ci sono zeri
		{
			if ( fabs ( A[i][k] ) > soglia )
			{
			soglia=fabs(A[i][k]); icmax=i;
			}
		}
		if (icmax!=k) // se icmax  diverso da l'indice k attuale allora swappa
		{             // altrimenti fattorizza solamente
			dete=-dete;  //  printf("\ndete in swap=%f",dete);getch();
			for (m=k; m<n; m++)
			{           // inizio swap
				C[m]=A[icmax][m];   // irmax in realt
				A[icmax][m]=A[k][m];
				A[k][m]=C[m];
			}
		}     // fine swap
//                    triangolarizzazione superiore
		for (i=k+1; i<n; i++)
		{
			if (A[k][k]==0)
				{
				printf("\n ERRORE ! ! la matrice non  fattorizzabile \n");
				exit(0);
				}
			lik=A[i][k]/A[k][k];     // printf("\n lik=%f  i=%d k=%d",lik,i,k);
			for (jj=k; jj<n; jj++)
			{
				A[i][jj]=A[i][jj]-lik*(A[k][jj]);
			}
		}
	} // fine del for k
// calcolo del determinante: prodotto diagonale  principale
	for (m=0;m<n;m++) dete=dete*A[m][m];
	return (dete);
}


double zeri_sec(double Nef,double oldNef,double deter,double olddeter,
				double eps, double k0)
{
	int j=0;
	double fl,f,dx,swap,xl,rts;

		fl=deter;       //(*func)(x1);
		f=olddeter;    //(*func)(x2);
	if (fabs(fl) < fabs(f)) {
		rts=Nef;
		xl=oldNef;
		swap=fl;
		fl=f;
		f=swap;
	} else {
		xl=Nef;
		rts=oldNef;
	}
	for (j=1;j<=MAXIT;j++) {
		dx=(xl-rts)*f/(f-fl);
		xl=rts;
		fl=f;
		rts += dx; Nef=rts;
		gotoxy(60,21+nj); delay(30);printf("Nef[%d]=%2.9f",nj,Nef);
		f=calcolo_dete(No1, No2, No3, No4, No5, k0, Nef);  //(*func)(rts);
		if (fabs(dx) < eps || f == 0.0) return rts;
	}
	printf("\nERRORE !! Superato il massimo numero di iterate");
	printf("\nIl metodo non converge !!");  exit(1);
	return 0.0;
}


void verif_nef(double X[5], double Nef)
{
	double acc;
	//printf("\nA1=x0=%f A3=x1=%f A4=x2=%f B3=x3=%f B4=x4=%f"
	//              ,X[0],X[1],X[2],X[3],X[4]);
	//printf("\n  ver neff    Nef=%f  ",Nef);getch();
	acc=(-h4*sin(h4*(d3+d4)))*X[2]-(h4*cos(h4*(d3+d4))*X[4])+h5*exp(-h5*(d3+d4));
	gotoxy(1,21+nj);printf("Verifica accuratezza=%e per l'nef=%2.9f",acc,Nef);
}


int simq(void) //routine per la risoluzione del sistema di equazioni. Il C memorizza
{              //le matrici non per colonne come il fortran ma per righe
	int i, j, ij, ip, ipj, ipk, ipn;
	int idxpiv, iback;
	int k, kp, kp1, kpj, kpk, kpn;
	int nip, nkp, nm1;
	double em, q, rownrm, big, size, pivot, sum;

	double A[25], B[5], X[5];
	int IPS[5], n=5, flag=0;

	B[0]=B[1]=B[2]=B[3]=0 ;B[4]=exp(-h1*(d3+d4));

	A[4]=A[2]=A[7]=A[9]=A[10]=A[15]=A[20]=A[21]=A[23]=A[24]=0;

	A[0]=exp(-h1*d2);      A[1]=(h3/h2*sin(h2*d2))-cos(h2*d2);

	A[3]=(-cos(h2*d2))-(h3/h2*sin(h2*d2));

	A[5]=h1*exp(-h1*d2);   A[6]=(-h3*cos(h2*d2))-h2*sin(h2*d2);

	A[8]=(-h2*sin(h2*d2))+h3*cos(h2*d2);        A[11]=exp(h3*d3);

	A[12]=-cos(h4*d3);     A[13]=exp(-h3*d3);   A[14]=sin(h4*d3);

	A[16]=h3*exp(h3*d3);  A[17]=h4*sin(h4*d3);   A[18]=-h3*exp(-h3*d3);

	A[19]=h4*cos(h4*d3); A[22]=cos(h4*(d3+d4));  A[24]=-sin(h4*(d3+d4));

	if( flag < 0 )
		goto solve;
/* 	     Inizializza IPS ed X    */

		ij=0;
	for( i=0; i<n; i++ )
		{
		IPS[i] = i;
		rownrm = 0.0;
		for( j=0; j<n; j++ )
		{
			q = fabs( A[ij] );
			if( rownrm < q )
				rownrm = q;
			++ij;
			}
		if( rownrm == 0.0 )
			{
			puts("Errore c' una riga=0");
			return(1);
			}
		X[i] = 1.0/rownrm;
		}
/*  	    eliminazione di Gauss con pivot parziale        */
	nm1 = n-1;
	for( k=0; k<nm1; k++ )
		{
		big= 0.0;
		for( i=k; i<n; i++ )
			{
			ip = IPS[i];
			ipk = n*ip + k;
			size = fabs( A[ipk] ) * X[ip];
			if( size > big )
				{
				big = size;
				idxpiv = i;
				}
			}
		if( big == 0.0 )
			{
			puts( "SIMQ BIG=0 non posso fattorizzare !" );
			return(2);
			}
		if( idxpiv != k )
			{
			j = IPS[k];
			IPS[k] = IPS[idxpiv];
			IPS[idxpiv] = j;
			}
		kp = IPS[k];
		kpk = n*kp + k;
		pivot = A[kpk];
		kp1 = k+1;
		for( i=kp1; i<n; i++ )
			{
			ip = IPS[i];
			ipk = n*ip + k;
			em = -A[ipk]/pivot;
			A[ipk] = -em;
			nip = n*ip;
			nkp = n*kp;
			for( j=kp1; j<n; j++ )
				{
				ipj = nip + j;
				A[ipj] = A[ipj] + em * A[nkp + j];
				}
			}
		}
	kpn = n * IPS[n-1] + n - 1;     /* ultimo elemento della IPS[n]esima riga */
	if( A[kpn] == 0.0 )
		{
		puts( "SIMQ il determinante  A[kpn]=0");
		return(3);
		}
/*      	sostit all'indietro     */
	solve:

	ip = IPS[0];
	X[0] = B[ip];
	for( i=1; i<n; i++ )
		{
		ip = IPS[i];
		ipj = n * ip;
		sum = 0.0;
		for( j=0; j<i; j++ )
			{
			sum += A[ipj] * X[j];
			++ipj;
			}
		X[i] = B[ip] - sum;
		}

	ipn = n * IPS[n-1] + n - 1;
	X[n-1] = X[n-1]/A[ipn];
	for( iback=1; iback<n; iback++ )
		{
/*	 i va da (n-1),...,1  */
		i = nm1 - iback;
		ip = IPS[i];
		nip = n*ip;
		sum = 0.0;
		for( j=i+1; j<n; j++ )
			sum += A[nip+j] * X[j];
		X[i] = (X[i] - sum)/A[nip+i];
		}
// 	printf("\nsimq : RISULTATO ---> (x0=%f x1=%f x2=%f x3=%f x4=%f)"
// 	             ,X[0],X[1],X[2],X[3],X[4]);getch();
	verif_nef(X,Nef);
	campi_E(X);
	return(0);
}


void campi_E(double X[5])
{
	int  i, i2=0, i3=0, i4=0;
	double   mapmax=0.0, a2=0.0, b2=0.0, b5=0.0, deltax=0.0, x=0.0;

	a2=X[1]+X[3];   b2=h3/h2*(X[3]-X[1]);   b5=1.0;
	deltax=(d2+d3+d4)/(npix-60);

	i2=d2/deltax; i3=d3/deltax; i4=d4/deltax;//in i2/3/4 ci saranno i float troncati

//      printf("\n in campi_E  h1=%f h2=%f h3=%f h4=%f  h5=%f ",h1,h2,h3,h4,h5);
//      getch();
	x=d2+30.0*deltax+deltax; // l'origine  in a ??? o in b?? vedi appunti
//      printf("\n partenza x=%f a=%d b=%d nj=%d",x,a,b,nj); getch();
	for(i=0;i<31;i++)  // assumo di disegnare 30 punti del campo in sub.1
		{               // CONFUSIONE NEL DISEGNO SUI FOGLIETTI !!!!
		x=x-deltax;
//              printf("\nx=%f deltax=%f h1=%f X[0]=%f",x,deltax,h1,X[0]);
		matmap[nj][i]=X[0]*exp(-h1*x);   // Ey1
//      printf("\n sono nel primo for  matmap[%d][%d]=%f",nj,i,matmap[nj][i]);
		}
	x=d2;
//  printf("\n riparte da x=%f",x); getch();
//      printf("\nprima del II for i2=%d  a=%d   i4=%d ",i2,a,i4);
	a=31+i2;
//      printf("\nprima del II for  i=31 i<a   a=%d",a);
	deltax=d2/i2;
	for(i=31;i<a;i++)
		{
		x=x-deltax;
//              printf("\n  x=%f deltax=%f  a=%d",x,deltax,a);
		matmap[nj][i]=a2*cos(h2*x)+b2*sin(h2*x); // Ey2
//              printf("\n sono nel secondo for  map[%d]=%f",i,matmap[nj][i]);
		}
	b=31+i2+i3;
//  printf("\n i2=%d i3=%d i4=%d  deltax=%f ",i2,i3,i4,deltax);
	x=0.0;
//      printf("\n III for  int a=%d   b=%d  c=%d",a,b,c);getch();
	deltax=d3/i3;
	for(i=a;i<b;i++)
		{
		x=x-deltax;
//              printf("\n  x=%f deltax=%f  a=%d  b=%d c=%d",x,deltax,a,b,c);
		matmap[nj][i]=X[1]*exp(-h3*x)+X[3]*exp(h3*x); // Ey3
//              printf("\n sono nel terz  map[%d]=%f",i,matmap[nj][i]);
		}
	c=b+i4;  //c=31+i2+i3+i4
	x=-d3;
	deltax=d4/i4;
//      printf ("\n all' inizio del 4 for a=%d b=%d c=%d d=%d",a,b,c,d);getch();
	for(i=b;i<c;i++)
		{
		x=x-deltax;
//              printf("\nx=%f deltax=%f  a=%d   b=%d  c=%d d=%d",x,deltax,a,b,c,d);
		matmap[nj][i]=X[2]*cos(h4*x)+X[4]*sin(h4*x); // Ey4
//        printf("\n sono nel quarto map[%d]=%f",i,matmap[nj][i]);
		}
		d=c+30;// d=31+i2+i3+i4+30 o +31 ??
		x=-d3-d4;
//      printf("\nall' inizio del 5 for a=%d b=%d c=%d d=%d",a,b,c,d);getch();
	for(i=c;i<d;i++)
		{
		x=x-deltax;
//              printf("\n  x=%f deltax=%f  a=%d   b=%d",x,deltax,a,b);
		matmap[nj][i]=b5*exp(h5*x);       // Ey5
//              printf("\n sono nel quinto for matmap[%d][%d]=%f",nj,i,matmap[nj][i]);
		}
	mapmax=fabs(matmap[nj][0]);
	for(i=1;i<d;i++)  if (fabs(matmap[nj][i])>mapmax) mapmax = fabs(matmap[nj][i]);
	for(i=0;i<d;i++) matmap[nj][i]=matmap[nj][i]*100/mapmax;
// printf("\n  x=%f deltax=%f",x,deltax);
// printf("\nmapmax=%f",mapmax);getch();
}


void disegna()
{
	int 		i, posx=0, posy=195;
	double 	k0, dato=0.0;
	char 		key,  in[10];
	char 		lacc[8], elle[8], lam[8], nef0[13], nef1[13], nef2[13], nef3[13];
	char 		n1[7], n2[7], n3[7], n4[7], n5[7], di2[7], di4[7], gap[7];
	char		*stringa1="Lunghezza di accopp.=";
	char 		*elle1="Lunghezza guida lungo z=", *str=" micron";
	char 		*neff0="nef[0]=",*neff1="nef[1]=",*neff2="nef[2]=",*neff3="nef[3]=";
	char 		dest[30], dest1[30], dest2[30], dest3[30];

	posx=320-npix/2; flag=0;
	k0=2*pi/lambda;
	la=pi/(k0*(nefok[0]-nefok[1]));   l=la;
	if (nj==0) l=100.0; 		// se c' un solo modo assumo l=100
	setbkcolor(BLACK); cleardevice(); setviewport(0,0,639,479,0);
	setcolor(LIGHTGRAY); rectangle(0,0,639,390);  // la finestra
// disegno gli assi x,y
	settextstyle(SMALL_FONT,0,0); setcolor(RED);
	outtextxy(b+posx+40,353,"x");	outtextxy(b+posx-10,367,"y"); outtextxy(b+posx+3,344,"z");
	line(b+posx,340,b+posx,380); line(b+posx-20,355,b+posx+40,355);
// le freccette
	line(b+posx,380,b+posx-3,377); line(b+posx,380,b+posx+3,377); // asse y
	line(b+posx+40,355,b+posx+40-3,352); line(b+posx+40,355,b+posx+40-3,358);
// il disegno bidim dell'accoppiatore
	setcolor(GREEN);       rectangle(0+posx,posy-6,30+posx,posy+6);
	setcolor(CYAN);        rectangle(31+posx,posy-6,a-1+posx,posy+6);
	setcolor(LIGHTGREEN);  rectangle(a+posx,posy-6,b-1+posx,posy+6);
	setcolor(CYAN);        rectangle(b+posx,posy-6,c-1+posx,posy+6);
	setcolor(GREEN);       rectangle(c+posx,posy-6,d-1+posx,posy+6);
	setcolor(GREEN);
	outtextxy(0+posx+4,posy-7,"sub.");
	outtextxy(c+posx+(d-1-c)/2-10,posy-7,"sub.");
	setcolor(LIGHTGREEN);  outtextxy(a+posx+((b-1-a)/2)-10,posy-8,"gap");
	setcolor(CYAN);outtextxy(31+posx+((a-1-31)/2)-15,posy-7,"core1");
	outtextxy(b+posx+(c-1-b)/2-15,posy-7,"core2");
// le linee verticali tratteggiate
	setlinestyle(1,1,1);
	line(31+posx,posy+110,31+posx,posy-110);
	line(a-1+posx,posy+110,a-1+posx,posy-110);
	line(b+posx,posy+110,b+posx,posy-110);
	line(c-1+posx,posy+110,c-1+posx,posy-110);
	setlinestyle(0,1,1);
// disegna il modo pari e quello dispari
	for(i=0; i<d; i++)  putpixel(i+posx,-matmap[0][i]+posy,LIGHTRED);
	if (nj!=0) for(i=0; i<d; i++)  putpixel(i+posx,-matmap[1][i]+posy,LIGHTMAGENTA);
// scrive nella finestra la lungezza della guida e se  il laso la lung. di accopp.
	settextstyle(SMALL_FONT,0,0);  setcolor(BROWN);
	if (nj!=0)
		{
		gcvt(la,7,lacc);
		outtextxy(395,30,stringa1);outtextxy(535,30,lacc);outtextxy(595,30,str);
		}
	gcvt(l,7,elle);
	outtextxy(395,40,elle1); outtextxy(550,40,elle);outtextxy(595,40,str);
//	stampa gli indici efficaci nella finestra
	gcvt(No1,6,n1); gcvt(No2,6,n2); gcvt(No3,6,n3);
	gcvt(No4,6,n4); gcvt(No5,6,n5);
	gcvt(lambda,7,lam); gcvt(d2,6,di2); gcvt(d3,6,gap); gcvt(d4,6,di4);
	gcvt(nefok[0],12,nef0);
	strcpy(dest,neff0); strcat(dest,nef0);
	setcolor(LIGHTRED); outtextxy(500,60,dest);
	if (nj!=0)
		{
		setcolor(LIGHTMAGENTA);
		gcvt(nefok[1],12,nef1);
		strcpy(dest1,neff1); strcat(dest1,nef1);
		outtextxy(500,70,dest1);
		}
	setcolor(MAGENTA);
	outtextxy(10,400,"No1=");		outtextxy(35,400,n1);
	outtextxy(80,400,"No2="); 		outtextxy(105,400,n2);
	outtextxy(150,400,"No3="); 	outtextxy(175,400,n3);
	outtextxy(220,400,"No4="); 	outtextxy(245,400,n4);
	outtextxy(290,400,"No5="); 	outtextxy(315,400,n5);
	outtextxy(360,400,"d2=");  	outtextxy(380,400,di2);
	outtextxy(430,400,"gap="); 	outtextxy(455,400,gap);
	outtextxy(500,400,"d4=");     outtextxy(520,400,di4);
	outtextxy(555,400,"lambda=");	outtextxy(595,400,lam);

	// size=imagesize(posx-2,195-110,posx+npix+2,195+110);
	//graph=malloc(imagesize(posx,195-100,posx+npix,195+100));
	//getimage(posx,195-100,posx+npix,195+100,graph);
	//printf("\n size=%u  size hex=%x",size,size);

// men sull'ultima riga dello schermo
	setcolor(DARKGRAY);rectangle(0,450,639,479); setfillstyle(INTERLEAVE_FILL,DARKGRAY);
	floodfill(40,460,DARKGRAY);
	settextstyle(TRIPLEX_FONT,0,3);
	setcolor(LIGHTRED); outtextxy(30,449,"M");
	setcolor(CYAN);outtextxy(49,449,"odi");
	setcolor(LIGHTRED); outtextxy(125,449,"3");
	setcolor(CYAN);         outtextxy(139,449,"-D");
	setcolor(LIGHTRED); outtextxy(210,449,"D");
	setcolor(CYAN);               outtextxy(224,449,"ati");
	setcolor(LIGHTRED); outtextxy(288,449,"L");
	setcolor(CYAN);         outtextxy(300,449,"ung.acc.");
	setcolor(LIGHTRED); outtextxy(439,449,"E");
	setcolor(CYAN);         outtextxy(455,449,"ccita");
	setcolor(LIGHTRED); outtextxy(560,449,"Esc");
	setcolor(CYAN);         outtextxy(595,449,"i");
	do
	{
	key=tolower(getch());
	switch(key)
		{
		case 'm':
			if(flag)
				{
				setcolor(BLACK);  // effetto cancellazione finestra a dest e sin.
				for(i=0;i<319;i++)
					{
					line(319-i,1,319-i,389); line(320+i,1,320+i,389);
					}
//				disegno gli assi x,y
				settextstyle(SMALL_FONT,0,0); setcolor(RED);
				outtextxy(b+posx+40,353,"x");	outtextxy(b+posx-10,367,"y"); outtextxy(b+posx+3,344,"z");
				line(b+posx,340,b+posx,380); line(b+posx-20,355,b+posx+40,355);
// 			le freccette
				line(b+posx,380,b+posx-3,377); line(b+posx,380,b+posx+3,377); // asse y
				line(b+posx+40,355,b+posx+40-3,352); line(b+posx+40,355,b+posx+40-3,358);
//          il disegno bidim dell'accoppiatore
				setcolor(GREEN);       rectangle(0+posx,posy-6,30+posx,posy+6);
				setcolor(CYAN);        rectangle(31+posx,posy-6,a-1+posx,posy+6);
				setcolor(LIGHTGREEN);  rectangle(a+posx,posy-6,b-1+posx,posy+6);
				setcolor(CYAN);        rectangle(b+posx,posy-6,c-1+posx,posy+6);
				setcolor(GREEN);       rectangle(c+posx,posy-6,d-1+posx,posy+6);
				settextstyle(SMALL_FONT,0,0);           setcolor(GREEN);
				outtextxy(0+posx+4,posy-7,"sub.");
				outtextxy(c+posx+(d-1-c)/2-10,posy-7,"sub.");
				setcolor(LIGHTGREEN);  outtextxy(a+posx+((b-1-a)/2)-10,posy-8,"gap");
				setcolor(CYAN);outtextxy(31+posx+((a-1-31)/2)-15,posy-7,"core1");
				outtextxy(b+posx+(c-1-b)/2-15,posy-7,"core2");
//				le linee verticali tratteggiate
				setlinestyle(1,1,1);
				line(31+posx,posy+110,31+posx,posy-110);
				line(a-1+posx,posy+110,a-1+posx,posy-110);
				line(b+posx,posy+110,b+posx,posy-110);
				line(c-1+posx,posy+110,c-1+posx,posy-110);
				setlinestyle(0,1,1);

				for(i=0; i<d; i++)  putpixel(i+posx,-matmap[0][i]+posy,LIGHTRED);
				if (nj!=0)
					for(i=0; i<d; i++)  putpixel(i+posx,-matmap[1][i]+posy,LIGHTMAGENTA);
				settextstyle(SMALL_FONT,0,0);  setcolor(BROWN);
				if(nj!=0) //solo se ci sono pi di un modo c' la lung. acc.
					{
					gcvt(la,7,lacc);
					outtextxy(395,20,stringa1);outtextxy(535,20,lacc);outtextxy(595,20,str);
					}
				gcvt(l,7,elle);
				outtextxy(395,30,elle1); outtextxy(550,30,elle);outtextxy(595,30,str);
//				stampa gli indici efficaci nella finestra
				gcvt(No1,6,n1); gcvt(No2,6,n2); gcvt(No3,6,n3);
				gcvt(No4,6,n4); gcvt(No5,6,n5);
				gcvt(lambda,7,lam); gcvt(d2,6,di2); gcvt(d3,6,gap); gcvt(d4,6,di4);
				gcvt(nefok[0],12,nef0);
				strcpy(dest,neff0); strcat(dest,nef0);
				setcolor(LIGHTRED); outtextxy(500,60,dest);
				if (nj!=0)
					{
					setcolor(LIGHTMAGENTA);
					gcvt(nefok[1],12,nef1);
					strcpy(dest1,neff1); strcat(dest1,nef1);
					outtextxy(500,70,dest1);
					}
				}
				if (nj>=2)
					{
					settextstyle(SMALL_FONT,0,0);
					gcvt(nefok[2],12,nef2);
					strcpy(dest2,neff2); strcat(dest2,nef2);
					setcolor(4); outtextxy(500,80,dest2);
					}
				if (nj>=3)
					{
					settextstyle(SMALL_FONT,0,0);
					gcvt(nefok[3],12,nef3);
					strcpy(dest3,neff3); strcat(dest3,nef3);
					setcolor(5); outtextxy(500,90,dest3);
					}
				if (nj>1) //disegna i modi, se ci sono, oltre al pari e dispari
					{
					for (int j=2;j<=nj;j++)
						for(i=0;i<d;i++) putpixel(i+posx,-matmap[j][i]+posy,2+j);
					}
				key=' ';      // per restare nel while
				break;
		case '3' :  setcolor(BLACK);
					for(i=0;i<319;i++)
					  {
					  line(319-i,1,319-i,389); line(320+i,1,320+i,389);
					  }
					disegna_3d();
					key=' ';  // per restare nel while
					break;
		case ESC :  cleardevice(); closegraph(); exit(0);
					break;
		case 'l' :  setcolor(LIGHTGRAY);rectangle(540,358,639,390);
					settextstyle(TRIPLEX_FONT,0,1);
					setcolor(LIGHTGREEN);
					gotoxy(70,24);
					outtextxy(3,420,"Assegna il nuovo valore di L da diagrammare in 3D e premi invio:");
					dato=atof(gets(in));
					if (dato!=0) l=dato;
					if (l>1000 || l<=0) l=la;
					setcolor(BLACK);
					for(int ii=420;ii<450;ii++)
					  line(2,ii,639,ii);
					setcolor(BLACK);
					for(i=0;i<319;i++)
					  {
					  line(319-i,1,319-i,389); line(320+i,1,320+i,389);
					  }
					key=' ';
					disegna_3d();
					break;
		case 'e' :  settextstyle(TRIPLEX_FONT,0,1); // eccita
					setcolor(LIGHTGREEN);
					outtextxy(3,420,"Premi 1 per eccitare la guida 1 premi 2 per eccitare la guida 2:");
					key=getch();
					setcolor(BLACK);
					for(i=0;i<319;i++)
					  {
					  line(319-i,1,319-i,389); line(320+i,1,320+i,389);
					  }
					for(ii=420;ii<450;ii++)
					  line(2,ii,639,ii);
					if (key=='2' && segno==-1)
					  {
					  for(i=0;i<d;i++)
							matmap[1][i]=segno*matmap[1][i];
					  segno=1.0;
					  }
					if (key=='1' && segno==1)
					  {
					  segno=-1.0;
					  for(i=0;i<d;i++) matmap[1][i]=segno*matmap[1][i];
					  }
					disegna_3d();
					key=' ';  // per restare nel while
					break;
		case 'd' : 	system("5strati"); cleardevice(); closegraph();	exit(0);
					break;
		default  :  sound(500); delay(20); nosound(); key=' ';break;
		}
	}while( key==' ');
}
//###########################################################################
//################################         ##################################
//################################ M A I N ##################################


void main()
	{
	double k0=0.0, deltan=0.0;
	double deltadeltan=0.0;
	int i=0, j=0, errori=0;

	inizializza_grafica();
	if (!nefok) {
				printf("\nNon ho sufficiente memoria per il vett. degli nef");
				exit(0); // se il vettore dinamico non pu essere creato smetti.
				}
	for(i=0;i<6;i++) nefok[i]=0.0;
	for(j=0;j<300;j++) matmap[0][j]=0.0;
	for(j=0;j<300;j++) matmap[1][j]=0.0;
	for(j=0;j<300;j++) matmap[2][j]=0.0;
	for(j=0;j<300;j++) matmap[3][j]=0.0;
	for(j=0;j<300;j++) matmap[4][j]=0.0;
//      if (!matmap) printf ("\n    Non ho memoria suffic !!");
//      for (i=0;i<dim;i++)
//      {
//              matmap[i]=new double [dimmap		;
//              if (!matmap[i]) printf ("\n    Non ho memoria sufficiente  !!");
//      }
	do  errori=dati_in_ingresso(); while (errori);
	k0=2*pi/lambda;
	deltan=Nmax-Nmin;
	deltadeltan=deltan/step;
	Nef=Nmax-deltadeltan;
	trova_nef(deltadeltan,k0);
	sleep(3);
	disegna();
	closegraph();
	}
#undef MAXIT


//########################### F I N E  M A I N ##############################
//###########################################################################


void trova_nef(double deltadeltan,  double k0)
{
  double det=0.0, eps=1e-14, olddet=0.0, oldNef=0.0, limit=0.0, neftemp=0.0;

  limit=Nmin+2*deltadeltan; //se neff=nmin ho indetreminazione allora lo escludo
  do
  {
	  det=calcolo_dete(No1, No2, No3, No4, No5, k0, Nef);
	  do
	  {
	  olddet=det;  oldNef=Nef;
	  Nef=Nef-deltadeltan;//provo a step di deltadeltan se la funz. dete. cambia segno
//   mi muovo a ritroso da nmax fino ad arrivare ad nmin
//printf("\n  Nmax=%f  deltadeltan =%f",Nmax,deltadeltan);
//        printf("\n## tentativo di Neff=%f  limit =%f",Nef,limit);
	  det=calcolo_dete(No1, No2, No3, No4, No5, k0, Nef);
//        printf("\n det=%f olddet=%f",det,olddet);
//printf("\n subito prima del while limit limit=%f  nef=%f",limit,Nef);
	  } while( (Nef>limit) && ((det*olddet>0) || (Nef==Nmax-deltadeltan)) );
//controllo su l'indetrm. contr. sul cambio di segno   controllo per l'avvio
//printf("\n subito dopo del while limit limit=%f  nef=%f",limit,Nef);getch();
	  if (Nef>limit)//questo lo deve fare solo se sono ancora nell'intrevallo senza indeter.
		{
//      printf("\n         nel nuovo if limit limit=%f  nef=%f",limit,Nef);
		nj++;
		neftemp=Nef;
		nefok[nj]=zeri_sec(Nef, oldNef, det, olddet, eps, k0);
		sound(2000);delay(25);nosound();
		Nef=nefok[nj];
		simq();//trovo le costanti(nefok) da mettere nelle espress. dei campi
		Nef=neftemp;
//              printf("\n nefok[%d]=%f Nef=%f",nj,nefok[nj],Nef);
		}
	  if(nj>=4)//se trovo pi di 4 nef ferma!(togliendo questo controllo li trovo tutti)
		{
		printf("\nIl programma si ferma al 4 nef trovato !!");
		sound(4000); delay(50); nosound(); delay(2000);
		break; // esce dal while al 4 nefficace!!
		}
  }while(Nef>=limit);//quando ho cercato in tutto l'intervallo finisco
}


void disegna_3d()
{
	int     i=0, ii=0, hh=0, x=0, y=0, k=0, posx=20, posy=210, xx=0, yy=0;
	double  k0=0.0, dez=0.0, z=0.0, mapdispari[800], mappari[800];
	double  bb, cc, bbb, ccc, maptot[800], vet[30], vet1[30], dato=0.0;
	char    in[10], stringa[15], elle[15], strg[5];
	char    *stringa1="Lunghezza di accopp.=";
	char    *str=" micron", *elle1="Lunghezza guida lungo z=";

	k0=2*pi/lambda; flag=1;
	for(i=0; i<=30; i++) vet[i]=0.0;
	for(i=0; i<=30; i++) vet1[i]=0.0;
// trovo singolarmente il modo 3D pari e quello 3D dispari

//  l=pi/(k0*(nefok[0]-nefok[1]));
//  for(i=0;i<801;i++) mapdispari[i]=0.0;

/*  for(i=0;i<801;i++)
		{
		maptot[i]=0.0;
		mappari[i]=0.0;
		mapdispari[i]=0.0;
		}
  */
//  printf("\n prima della prova");getch();
//      for(i=0; i<d; i++)  putpixel(i+posx,-matmap[0][i]+posy,LIGHTRED);getch();
//      for(i=0; i<d; i++)  putpixel(i+posx,-matmap[1][i]+posy+130,LIGHTRED);

//      printf("sono in disegna k0=%f  pi=%f  lamb=%f  l=%f kmax=%d nj=%d dez=%f"
//              ,k0,pi,lambda,l,kmax,nj,dez);getch();

 //     printf("\nlunghezza d'accopp=%f micron",l);// getch();
 //     cleardevice();
/*
	lp=pi/(2*k0*nefok[0]);
	dez=lp/kmax;
	z=-dez;
 //     bb0=fabs(cos(k0*nefok[0]*z));
//      bb1=fabs(cos(k0*nefbuoni[1]*z));

  for(k=0;k<kmax;k++)
  {
	z=z+dez;
	bb=cos(k0*nefok[0]*z);
	for(i=0;i<d;i++)
		{
mappari[i]=bb*matmap[0][i];
//      printf("\nmappari[%d]=%f matmap[0][%d]=%f  bb=%f",i,mappari[i],i,matmap[0][i],bb);
		}
	for(i=0;i<d;i++)
		{
		putpixel(i+posx,-mappari[i]+posy,LIGHTCYAN);
			for (int g=1;g<20;g++)
				{
				putpixel(i+posx,-mappari[i]+posy+g,0);
				}
		}
	delay(500);
	posx=posx+10; posy=posy+2;
  }
  getch();
  posx=30, posy=100;

  ld=pi/(2*k0*nefok[1]);
  dez=ld/kmax;
  z=-dez;
  cleardevice();
  for(k=0;k<kmax;k++)
	{
	z=z+dez;
	bb=cos(k0*nefok[1]*z);
	for(i=0;i<d;i++)
	mapdispari[i]=bb*matmap[1][i];
	for(i=0;i<d;i++)
		{
		putpixel(i+posx,-mapdispari[i]+posy,LIGHTMAGENTA);
		}
	posx=posx+2; posy=posy+2;
	delay(400);
	}
  getch();      */
//printf("\nin disegna  a=%d b=%d c=%d d=%d",a,b,c,d);getch();
	settextstyle(SMALL_FONT,0,0);  setcolor(BROWN);
	if (nj!=0)
		{
		gcvt(la,7,stringa);
		outtextxy(395,20,stringa1);outtextxy(535,20,stringa);outtextxy(595,20,str);
		}
	gcvt(l,7,elle);
	outtextxy(395,30,elle1); outtextxy(550,30,elle);outtextxy(595,30,str);

	dez=l/(kmax);
	z=-dez;  posx=20; posy=210;
	x=posx; y=posy; xx=6; yy=4; // posx e posy sono le posiz di partenza
	if ((posy+yy*kmax+30>389) || (posx+xx*kmax+npix>638))
	{                 // se il grafico 3D esce dalla finestra
	xx=xx/2;   yy=yy/2;
	}
	if ((posy+yy*kmax+30>389) || (posx+xx*kmax+npix>638))
	{ //non dovrebbe capitare mai, solo se togli il controllo iniziale delle sezioni 20-74
	printf("\nIl grafico uscir dalla finestra riduci il n delle sez.(%d)-> ",kmax);
	dato=atoi(gets(in));
	if (dato==0) kmax=20;
	kmax=dato;
	}
	for(k=0;k<kmax;k++)
	{
	z=z+dez;
	cc=cos(k0*nefok[1]*z);
	ccc=sin(k0*nefok[1]*z);
	bb=cos(k0*nefok[0]*z);
	bbb=sin(k0*nefok[0]*z);
	for(i=0;i<d;i++)
		mappari[i]=(bb*matmap[0][i]+cc*matmap[1][i])*(bb*matmap[0][i]+cc*matmap[1][i]);
	for(i=0;i<d;i++)
		mapdispari[i]=(bbb*matmap[0][i]+ccc*matmap[1][i])*(bbb*matmap[0][i]+ccc*matmap[1][i]);
	for(i=0;i<d;i++)
		{
		maptot[i]=sqrt(mappari[i]+mapdispari[i]);
		}
	ii=0;
	for(i=10;i<d;i+=10)
		{
		vet[ii]=maptot[i];
		ii++;
		}
	if (k)
		{
		setcolor(LIGHTRED); // linee trasversali per l'effetto 3D
		for(i=0;i<ii;i++)
			 {
			 setlinestyle(1,1,1);
			 line(posx+10*(i+1)-xx,posy-vet1[i]-yy,posx+10*(i+1),posy-vet[i]);
			 delay(60);
			 setlinestyle(0,1,1);
			 }
		}
	for(hh=0;hh<=ii;hh++)   vet1[hh]=vet[hh];
	for(i=0;i<d;i++)
		{
		putpixel(i+posx,-maptot[i]+posy,LIGHTRED);
		for (int g=1;g<45;g++) //cancella dietro per la vista 3D 45punti in vert
				{
				putpixel(posx+i,posy-maptot[i]+g,0);
				}
		}
	posx=posx+xx; posy=posy+yy;//xx e yy indicano di quanto sposto ogni volta z
	if (kbhit()) break ;
	}
	kmax=kmax-1;
// disegno della guida tridimensionale (posx=sott,30; 31,a-1; a,b-1; b,c-1; c,d-1;
	settextstyle(SMALL_FONT,0,0);   //  posx+ ..   sempre sottinteso a tutti
	setcolor(GREEN);
	rectangle(0+x+xx*kmax,y+yy*kmax,30+x+xx*kmax,y+yy*kmax+25);
	setcolor(CYAN);
	rectangle(31+x+xx*kmax,y+yy*kmax,a-1+x+xx*kmax,y+yy*kmax+25);
	setcolor(LIGHTGREEN);
	rectangle(a+x+xx*kmax,y+yy*kmax,b-1+x+xx*kmax,y+yy*kmax+25);
	setcolor(CYAN);
	rectangle(b+x+xx*kmax,y+yy*kmax,c-1+x+xx*kmax,y+yy*kmax+25);
	setcolor(GREEN);
	rectangle(c+x+xx*kmax,y+yy*kmax,d-1+x+xx*kmax,y+yy*kmax+25);
	setcolor(GREEN);        outtextxy(0+x+xx*kmax+5,y-1+yy*kmax,"sub.");
	gcvt(No1,4,strg);       outtextxy(0+x+xx*kmax+5,y-1+yy*kmax+12,strg);
	outtextxy(c+x+xx*kmax+(d-c)/2-10,y-1+yy*kmax,"sub.");
	gcvt(No5,4,strg);    outtextxy(c+x+xx*kmax+(d-c)/2-10,y-1+yy*kmax+12,strg);//printf(strg);
	setcolor(CYAN);
	outtextxy(31+x+xx*kmax+((a-1-31)/2)-15,y-1+yy*kmax,"core1");
	gcvt(No2,4,strg);       outtextxy(31+x+xx*kmax+((a-1-31)/2)-9,y-1+yy*kmax+12,strg);
	outtextxy(b+x+xx*kmax+(c-1-b)/2-15,y-1+yy*kmax,"core2");
	gcvt(No4,4,strg);       outtextxy(b+x+xx*kmax+(c-1-b)/2-9,y-1+yy*kmax+12,strg);
	setcolor(LIGHTGREEN);
	outtextxy(a+x+((b-1-a)/2)-10+xx*kmax,y-2+yy*kmax,"gap");
	gcvt(No3,4,strg);       outtextxy(a+x+((b-1-a)/2)-10+xx*kmax,y-1+yy*kmax+12,strg);
	setcolor(GREEN);
	moveto(x+xx*kmax,y+yy*kmax);   lineto(x,y);   lineto(x,y+25);
	lineto(x+xx*kmax,y+yy*kmax+25);
	setlinestyle(1,1,1);
	line(30+x+xx*kmax,y+yy*kmax,x+30,y);
	line(x+c,y,x+c+xx*kmax,y+yy*kmax);
	line(x+d-1,y,x+d-1+xx*kmax,y+yy*kmax); setlinestyle(0,1,1);
	setcolor(CYAN);
	setlinestyle(1,1,1); line(31+x+xx*kmax,y+yy*kmax,x+31,y);
	line(a-1+x+xx*kmax,y+yy*kmax,x+a-1,y);
	line(b+x+xx*kmax,y+yy*kmax,x+b,y);
	line(c-1+x+xx*kmax,y+yy*kmax,x+c-1,y);
	setcolor(LIGHTGREEN);
	line(a+x+xx*kmax,y+yy*kmax,x+a,y);
	line(b-1+x+xx*kmax,y+yy*kmax,x+b-1,y);
	moveto(x,y);
	setcolor(GREEN);lineto(x+30,y);
	setcolor(CYAN);line(x+31,y,x+a-1,y);
	setcolor(LIGHTGREEN);line(x+a,y,x+b-1,y);
	setcolor(CYAN);line(x+b,y,x+c-1,y);
	setcolor(GREEN);line(x+c,y,x+d-1,y);   setlinestyle(0,1,1);
	kmax=kmax+1;
}






